SystemOrganization addCategory: #'PetitCoral-Core'!
SystemOrganization addCategory: #'PetitCoral-Tests'!

PPSmalltalkGrammar subclass: #PPCoralGrammar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PetitCoral-Core'!

!PPCoralGrammar methodsFor: 'grammar-methods' stamp: 'StephaneDucasse 9/30/2009 16:40'!
methodDeclaration
	

	^  self methodLocation, super methodDeclaration! !

!PPCoralGrammar methodsFor: 'grammar-methods' stamp: 'StephaneDucasse 9/30/2009 16:34'!
methodLocation
	
	^ identifierToken , $> asParser, $> asParser! !

!PPCoralGrammar methodsFor: 'grammar-methods' stamp: 'StephaneDucasse 9/30/2009 16:52'!
methodSequence
	^ ($[ asParser token, $. asParser token star , pragmas , temporaries , pragmas , statements, $] asParser token) ==> 
		[ :nodes | 
		Array 
			with: nodes third , nodes fifth
			with: nodes fourth
			with: nodes sixth  ]! !

PPSmalltalkGrammarTests subclass: #PPCoralGrammarTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PetitCoral-Tests'!

!PPCoralGrammarTests methodsFor: 'accessing' stamp: 'StephaneDucasse 9/30/2009 16:18'!
parserClass
	^ PPCoralGrammar! !

!PPCoralGrammarTests methodsFor: 'testing' stamp: 'StephaneDucasse 9/30/2009 16:52'!
testMethod1
	"self debug: #testMethod1"

	self 
		parse: 'Point>>coralNegated [^ 0 - self]'
		rule: #method
		
	! !

!PPCoralGrammarTests methodsFor: 'testing' stamp: 'StephaneDucasse 9/30/2009 16:54'!
testMethod2
	"self debug: #testMethod2"

	"for now let us test the following"
	self 
		parse: '   Point >> coralNegated 
						[ ^ 0 - self] '
		rule: #method
		
	! !

!PPCoralGrammarTests methodsFor: 'testing' stamp: 'StephaneDucasse 9/30/2009 16:54'!
testMethod3
	"self debug: #testMethod3"

	"for now let us test the following"
	self 
		parse: '   Point >> coralNegated [^ 0 - self]     '
		rule: #method
	! !
